#ifndef MY_DIM
#error MY_DIM unset
#endif

#include "../explicitgrid.hh"
#include "../explicitvectors.hh"

#include <dune/solvers/solvers/loopsolver.hh>

#include "../../dune/tectonic/globalfriction.hh"
#include "tnnmg/functional.hh"
#include "tnnmg/zerononlinearity.hh"

#include "../data-structures/contactnetwork.hh"

#include "solverfactory.hh"

using MyGlobalFriction = GlobalFriction<Matrix, Vector>;

using MyFunctional = Functional<Matrix&, Vector&, MyGlobalFriction&, Vector&, Vector&, double>;
using MyZeroFunctional = Functional<Matrix&, Vector&, ZeroNonlinearity&, Vector&, Vector&, double>;

using MyLinearSolver = Dune::Solvers::LoopSolver<Vector>;

using MyContactNetwork =  ContactNetwork<Grid, Vector>;

using MySolverFactory = SolverFactory<MyFunctional, BitVector>;
template class SolverFactory<MyFunctional, BitVector>;
template<> template<> SolverFactory<MyFunctional, BitVector>::SolverFactory(const Dune::ParameterTree&, MyFunctional&, MyLinearSolver&&, const BitVector&, const MyContactNetwork&);

using MyZeroSolverFactory = SolverFactory<MyZeroFunctional, BitVector>;
template class SolverFactory<MyZeroFunctional, BitVector>;
/*template<> SolverFactory<MyZeroFunctional, BitVector>::SolverFactory(Dune::ParameterTree const &,
                                                               MyZeroFunctional&,
                                                               MyLinearSolver&&,
                                                               const BitVector&);*/
